'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'
'                    PC FAN Controler Soft for ATmega
'
'                                  Rev.7.40 for mega328p
'
'                                                    2014.10 by T.Sugiyama
'
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'
' F7.00  
' F7.11  t@ċN̋蓮ݒł悤ɕύX
' F7.20@ōxgp@\ǉ , Ŝ̍\
' F7.30@gxv@\ǉ
' F7.40  ]ZTɑΉ
'
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

'$sim

$regfile = "m328pdef.dat"
$crystal = 8000000
$hwstack = 160
$swstack = 160
$framesize = 160
$baud = 9600

'---------------------------------------------------------------------------------
'          Rev7.0̐ݒ
'---------------------------------------------------------------------------------
Const Fancon_Rev   = "---------------Rev7.0---------------"
Const Firm_Version = "F7.40"   't@[o[W
Const FAN_Max      = 4         't@ڑ䐔i]ZT̐j
Const PWM_Max      = 4         't@CHiPWM`lj
Const THM_Max      = 6         'xv䐔
Const Imp_THM_Max  = 4         'T[~X^xv䐔
Const Exp_THM_Max  = 2         'gxv䐔
Const Ext_Eff_cnt_max = 8       'L̍őli^[j

']vp萔Eϐ
Const Tmr_clock  = 8000       '8000kHz=CPU Clock (kHz)
Const Tmr_cycle  =  128       'Timer2 Count Cycle = 1024/Tmr_clock(us) ( prescale=1024 )
Const Tmr_top    =  256       'Timer2̃JEgTOPl
Const Tmr_over   =  326       'Timer2 Overflow Time = Tmr_cycle*Tmr_top (0.1ms),Timer2 Overflow time=32.768ms
Const Tmr_over_cnt_max  = 15  'v=Tmr_over_cnt_max*Tmr_over=491.52ms,Timer2 Time Out Count
Const Tmr_over_cnt_max2 =  6  'v=Tmr_over_cnt_max*Tmr_over=196.61ms,Timer2 Time Out Count
Const Fan_puls_min_wdth =  7  'ŏpX = Fan_puls_min_wdth * Tmr_cycle = 1(ms)

'FANoPin(PWM)
FAN1out Alias PinD.6  'FAN#1 PWM Pin
FAN2out Alias PinD.5  'FAN#2 PWM Pin
FAN3out Alias PinB.2  'FAN#3 PWM Pin
FAN4out Alias PinB.1  'FAN#4 PWM Pin
FAN5out Alias PinB.2  'FAN#5 PWM Pin (Dummy)
FAN6out Alias PinB.1  'FAN#6 PWM Pin (Dummy)

'PWM Duty
FAN1PWM Alias PWM0A   'FAN#1 PWM Duty
FAN2PWM Alias PWM0B   'FAN#2 PWM Duty
FAN3PWM Alias PWM1B   'FAN#3 PWM Duty
FAN4PWM Alias PWM1A   'FAN#4 PWM Duty
FAN5PWM Alias PWM1B   'FAN#5 PWM Duty (Dummy)
FAN6PWM Alias PWM1A   'FAN#6 PWM Duty (Dummy)

'FAN]pX
FAN1sens Alias PinC.0 'FAN#1 Speed Sensor
FAN2sens Alias PinD.3 'FAN#2 Speed Sensor
FAN3sens Alias PinC.1 'FAN#3 Speed Sensor
FAN4sens Alias PinD.2 'FAN#4 Speed Sensor
FAN5sens Alias PinC.1 'FAN#5 Speed Sensor (Dummy)
FAN6sens Alias PinD.2 'FAN#6 Speed Sensor (Dummy)

'xvADC`l
Dim ADC_Thm( 4 ) As  Byte
ADC_Thm(1)=5 : ADC_Thm(2)=4 : ADC_Thm(3)=3 : ADC_Thm(4)=2

'AUX output Port
AUXPort0 Alias PortB.0
AUXPort1 Alias PortD.7
AUXPort2 Alias PortB.7
AUXPort3 Alias PortB.6
AUXPort4 Alias PortD.4
AUXPort5 Alias PortB.3
AUXPort6 Alias PortB.4
AUXPort7 Alias PortB.5

'|[g̃vAbv
PortB=&B11111001
PortC=&B01000011
PortD=&B10011100

'ovlݒ  prescale= 1,8,64,256,1024   clear timer= 0;Phase Correct PWM Mode, 1;Fast PWM Mode
'Config Timer1 = Pwm , Prescale = 1 , Clear Timer = 1 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down , Pwm = 8
TCCR1A = &B10100010
TCCR1B = &B00011001
TCCR1C = &B00000000
TIMSK1 = 0
ICR1   = 100
Set DDRB.1
Set DDRB.2
Config Timer0 = Pwm , Prescale = 1 , Clear Timer = 1 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up
Const PWMtop1 = 255
Const PWMtop2 = 255
Const PWMtop3 = 100
Const PWMtop4 = 100
Const PWMtop5 = 100  'Dummy
Const PWMtop6 = 100  'Dummy

'^C}[уt@ZT[݂̐ݒ i]vɎgpj
Config Timer2 = Timer , Prescale = 1024
On Timer2 Tmr_int nosave

'---------------------------------------------------------------------------------
' AVR pin assign
'
'  1: RESET         : ISP Reset
'  2: PD0(RxD)      : Serial UART
'  3: PD1(TxD)      : Serial UART
'  4: PD2(PCINT18)  : FAN#4 Speed Sensor
'  5: PD3(PCINT19)  : FAN#2 Speed Sensor
'  6: PD4(PCINT20)  : AUXPort4
'  7: Vcc
'  8: GND
'  9: XTAL1(PCINT6) : AUXPort3
' 10: XTAL2(PCINT7) : AUXPort2
' 11: PD5(OC0B)     : FAN#2 PWM
' 12: PD6(OC0A)     : FAN#1 PWM
' 13: PD7(PCINT23)  : AUXPort1
' 14: PB0(PCINT0)   : AUXPort0
' 15: PB1(OC1A)     : FAN#4 PWM
' 16: PB2(OC1B)     : FAN#3 PWM
' 17: PB3(MOSI)     : ISP MOSI , AUXPort5
' 18: PB4(MISO)     : ISP MISO , AUXPort6
' 19: PB5(SCK)      : ISP SCK  , AUXPort7
' 20: AVcc
' 21: Aref
' 22: AGND
' 23: PC0(PCINT8)   : FAN#1 Speed Sensor
' 24: PC1(PCINT9)   : FAN#3 Speed Sensor
' 25: PC2(ADC2)     : Thermistor#4
' 26: PC3(ADC3)     : Thermistor#3
' 27: PC4(ADC4)     : Thermistor#2
' 28: PC5(ADC5)     : Thermistor#1

'---------------------------------------------------------------------------------

'  ȍ~Rev3.0,Rev4.0,Rev5.0,Rev7.0ŋ

'---------------------------------------------------------------------------------
'         e錾
'---------------------------------------------------------------------------------

'PINݒ
Config FAN1out = Output     'FAN#1 PWM
Config FAN2out = Output     'FAN#2 PWM
Config FAN3out = Output     'FAN#3 PWM
Config FAN4out = Output     'FAN#4 PWM
Config FAN5out = Output     'FAN#5 PWM
Config FAN6out = Output     'FAN#6 PWM

Config FAN1Sens = Input     'FAN#1 Speed Sensor
Config FAN2sens = Input     'FAN#2 Speed Sensor
Config FAN3sens = Input     'FAN#3 Speed Sensor
Config FAN4sens = Input     'FAN#4 Speed Sensor
Config FAN5sens = Input     'FAN#5 Speed Sensor
Config FAN6sens = Input     'FAN#6 Speed Sensor

Config AUXPort0 = Output    'AUXPort0 (ŏIFan̖O"off"̂ƂLow)

'`cRo[^ݒ
Config Adc = Single , Prescaler = Auto , Reference = AVCC

'VA|[g̐ݒ
Config Serialin = Buffered , Size = 250

'ϐ錾

'e|ϐ
Dim Igr1 As Integer
Dim Igr2 As Integer
Dim Igr3 As Integer

Dim Sgl1 As Single
Dim Sgl2 As Single
Dim Sgl3 As Single

Dim Str1 As String * 10
Dim Str2 As String * 10
Dim Str3 As String * 10

'ϐ
Dim USB_data As String * 128
Dim StrArray(12) As string * 10

'`lIpϐ
Dim Thm_chan As Byte    'T[~X^
Dim Fan_chan As Byte    't@
Dim Adc_chan As Byte    '`cRo[^

'lpϐ
Dim Thm_Volt_ratio As Word    'T[~X^di0`1023j
Dim Tmpr           As Single  'xij
Dim MaxTmpr        As Single  'Maximum Temperature among all sensors(deg)
Dim Fan_tach       As Integer '](rpm)
Dim WriteParamReq  As Integer 'Request for write EEPROM ( 1: Write, 0: No write )
Fan_tach = 0
WriteParamReq = 0

Dim Tmr_max           As Integer   'Timer2 Overflow Count Max
Dim Tmr_over_cnt      As Integer   'Timer2 Overflow Count
Dim Tmr_over_cnt_arg  As Integer   'Timer2 Overflow Count Argument
Dim Tmr_cnt_arg       As Integer   'Timer2 Count Argument
Dim Tmr_total_cnt     As Integer   'Total counts of Timer2 = Tmr_over_cnt * Tmr_top + Timer2
Dim Tmr_total_cnt_pr  As Integer   'Value of Tmr_total_cnt at Previous Fan sensor pulse
Dim Fan_cnt           As Integer   'Fan Pulse Counter
Dim Fan_stop_flag     As Integer   'All Fan Stop flag (0:Stop)
Dim Pci_flag          As Byte      'PCINT interrupt flag

'ovlpϐ
Dim Pwm_duty( FAN_Max ) As Single        'ovlDutyl(0.0`100.0%)
Dim Pwm_top ( 6 )       As Byte          'ovl̐ݒől
Pwm_top( 1 ) = PWMtop1 : Pwm_top( 2 ) = PWMtop2
Pwm_top( 3 ) = PWMtop3 : Pwm_top( 4 ) = PWMtop4
Pwm_top( 5 ) = PWMtop5 : Pwm_top( 6 ) = PWMtop6

'vʊi[pϐ
Dim Temper    ( THM_Max ) As Single      'xij
Dim Tach      ( FAN_Max ) As Integer     ']ij
Dim Fan_status( FAN_Max ) As Integer     'Dutyp]
Dim Stp_flag  ( FAN_Max ) As Byte        'Fan~tO(1:~,0:N)
For Igr1 = 1 To FAN_Max
   Pwm_duty  ( Igr1 ) = 100.0
   Tach      ( Igr1 ) = 0
   Fan_status( Igr1 ) = 0
   Stp_flag  ( Igr1 ) = 0
Next
For Igr1 = 1 To THM_Max
   Temper( Igr1 ) = 0.0
Next

'Fancon parameter
Dim Tmin   ( PWM_Max ) As Integer   at &H0400  ' Temperature at minimum Fan Duty (deg)
Dim Tmax   ( PWM_Max ) As Integer   at &H0408  ' Temperature at maximum Fan Duty (deg)
Dim Tstop  ( PWM_Max ) As Integer   at &H0410  ' Fan Stops under this Temperature(deg)
Dim Dmin   ( PWM_Max ) As Integer   at &H0418  ' Minimum Fan Duty(%)
Dim Dmax   ( PWM_Max ) As Integer   at &H0420  ' Maximum Fam Duty(%)
Dim Dman   ( PWM_Max ) As Integer   at &H0428  ' Manual Duty of Fan channel(%)
Dim FanThm ( PWM_Max ) As Integer   at &H0430  ' Number of Thermistor controling Fan cannel
Dim Fanman ( PWM_Max ) As Integer   at &H0438  ' Manual or Auto control 1:Manual 0:Auto
Dim Fanpls ( FAN_Max ) As Integer   at &H0444  ' Fan Pulse Number in a Revolution 2:Normal Fan
Dim Fanname( FAN_Max ) As String * 6            ' Fan Name
Dim Thmname( THM_Max ) As String * 6            ' Thermistor Name
Dim Tfnc5  ( 8 )       As Integer               ' Coefficiect for Tmp5 function
Dim Tfnc6  ( 8 )       As Integer               ' Coefficiect for Tmp6 function
Dim FanPrm ( 32 )      As Integer   at &H0400 Overlay ' Equivalent Fancon Param
Dim PrmNam ( 8 )       As String * 6           ' Fancon Param Names
PrmNam(1) = "Tmin"   : PrmNam(2) = "Tmax"   : PrmNam(3) = "Tstop"
PrmNam(4) = "Dmin"   : PrmNam(5) = "Dmax"   : PrmNam(6) = "Dman"
PrmNam(7) = "FanThm" : PrmNam(8) = "FanMan"

't@R萔і́iEEPROMɊi[j
Dim eTmin   ( PWM_Max ) As ERAM Integer  at   0 'DminƂȂ鉷xij
Dim eTmax   ( PWM_Max ) As ERAM Integer  at   8 'DmaxƂȂ鉷xij
Dim eTstop  ( PWM_Max ) As ERAM Integer  at  16 'Fan~xij
Dim eDmin   ( PWM_Max ) As ERAM Integer  at  24 'Tminł̃f[eBij
Dim eDmax   ( PWM_Max ) As ERAM Integer  at  32 'Tmaxł̃f[eBij
Dim eDman   ( PWM_Max ) As ERAM Integer  at  40 '蓮̃f[eBij
Dim eFanThm ( PWM_Max ) As ERAM Integer  at  48 't@𐧌䂷鉷xvԍ
Dim eFanMan ( PWM_Max ) As ERAM Integer  at  56 't@@1:蓮@0:
Dim eFanPls ( FAN_Max ) As ERAM Integer  at  64 'Fan Pulse Number in a Revolution 2:Normal Fan
Dim eFanname( FAN_Max ) As ERAM String*6 at  76 't@
Dim eThmname( THM_Max ) As ERAM String*6 at 118 'xv
Dim eTfnc5  ( 8 )       As ERAM Integer  at 160 'Coefficiect for Tmp5 function
Dim eTfnc6  ( 8 )       As ERAM Integer  at 176 'Coefficiect for Tmp6 function
Dim eFanPrm ( 32 )      As Eram Integer  at   0 Overlay ' Equivalent Fancon Param

'O։xpϐ
Dim ExtTemper( THM_Max )  As Single      'O͉xij
Dim Ext_Eff_cnt           As Integer     'O։x̎cLi^[j
Ext_Eff_cnt = 0

'eXg[hpϐ
Const Test_Max = 10
Dim   Test_cnt As  Integer
Test_cnt = 0

'Tu[`ъ֐錾

'VA|[go͗pTu[`
Declare Sub SndPrm( )
Declare Sub RcvPrm( )
Declare Sub WrtPrm( )

'FAN PWMݒpTu[`
Declare Sub Set_Speed     ( Fan_chan_arg As Byte )
Declare Sub Set_Speed_full( )
Declare Sub Set_speed_zero()

'Read and Write EEPROM
Declare Sub ReadEEPparam ()
Declare Sub WriteEEPparam()

'AvZTu[`
Declare Function Temperature( Thm_Volt_ratio_arg As Word ) As Single
Declare Function ExpThm     ( Thm_chan_arg As Byte       ) As Single
Declare Function WtdAveTemp ( Thm_chan_arg As Byte       ) As Single
Declare Function Duty       ( Fan_chan_arg As Byte , Tmpr_arg As Single ) As Single
Declare Function Fanspeed   ( Fan_Chan_arg AS Byte       ) AS Integer
Declare Function Tmr_Count  () As Integer

'pt@NV
Declare Function Name_Str( Cliped_arg As String ) As String
Declare Function Tach_Str( Tach_arg As Integer  ) As String
Declare Function Temp_Str( Temp_arg As Single   ) As String
Declare Function Duty_Str( Duty_arg As Single   ) As String

'Test Mode Tu[`
Declare Sub TestMode( Test_mode_Fan_chan_arg As Byte )

'----------------------------------- Main Routine --------------------------------

Config Watchdog = 8192
Start Watchdog

't@Rp[^EEPROM畜
ReadEEPparam

'N@tXs[h 3Sec
Call Set_Speed_Full( )

Enable Interrupts

'[v
Do

'  t@Rp[^EEPROM畜
   ReadEEPparam

'  x
   Start Adc
   MaxTmpr = 0.0
   For Thm_chan = 1 To THM_Max

      If Thm_chan <= Imp_THM_Max Then

         Adc_chan = ADC_Thm( Thm_chan )
         Thm_Volt_ratio = Getadc( Adc_chan )
         Temper( Thm_chan ) = Temperature( Thm_Volt_ratio )

         'O։xgp
         If Ext_Eff_cnt > 0 Then
            If ExtTemper( Thm_chan ) > 5.0 Then
               Temper( Thm_chan ) = ExtTemper( Thm_chan )
            Endif
         Endif

         'ōx
         Tmpr = Temper( Thm_chan )
         If Tmpr < 99.9 Then
            If Tmpr > MaxTmpr Then
               MaxTmpr = Tmpr
            End If
         End If

      Else

         Temper( Thm_chan ) = ExpThm( Thm_chan )

      End If


      'PCɕ
      Sgl1 = Temper( Thm_chan )  : Str1 = Temp_Str( Sgl1 )
      Str2 = Thmname( Thm_chan ) : Str2 = Name_Str( Str2 )
      Print "Thm ," ; Thm_chan ; "," ; Str2  ; "," ; Str1

      Reset Watchdog

   Next Thm_chan
   Stop Adc

'   Print

   If Ext_Eff_cnt > 0 Then
      Ext_Eff_cnt = Ext_Eff_cnt - 1
   Else
      Ext_Eff_cnt = 0
   Endif

'  f[eBݒ

   For Fan_chan = 1 To FAN_Max

      If Fan_chan > PWM_Max Then  ' Rev4.0

         Igr1 = FAN_Max  - PWM_Max
         Igr1 = Fan_chan - Igr1
         PWM_duty( Fan_chan ) = PWM_duty( Igr1 )
         Stp_flag( Fan_chan ) = Stp_flag( Igr1 )

      Else

         Thm_chan = FanThm( Fan_chan )
         If Thm_chan <> 0 Then
            Tmpr = Temper( Thm_chan )
         Else
            Tmpr = MaxTmpr
         End If
         Pwm_duty( Fan_chan ) = Duty( Fan_chan, Tmpr )
         Call Set_Speed( Fan_chan )

      Endif

      Reset Watchdog

   Next Fan_chan

'@]

   For Fan_chan = 1 TO FAN_Max

      Tmr_max = Tmr_over_cnt_max
      Fan_Tach = Fanspeed( Fan_chan )

'     ]O񑪒ɈĂOɂȂ̏
'        Y`lAݒ(FanMan=0)Aቷɂ~łȂ(Stp_flag=0)
'        ̎́ADutyDmanƂčċNB
'        ADman=0͉̎sȂBi2sFanΉj

      If Fan_chan <= PWM_Max Then
         If Fan_Tach = 0 Then
            If Tach( Fan_chan ) = 0 Then       'When Tach is 0 in two consecutive
               If Fanman(Fan_chan) = 0 Then
                  If Stp_flag( Fan_chan ) = 0 Then
                     If Dman( Fan_chan ) > 0 Then
                        If PWM_duty( Fan_chan ) > 0 Then
                           Igr1 = Dman( Fan_chan )
                           Pwm_duty( Fan_chan ) = Igr1
                           Call Set_Speed( Fan_chan )
                        Endif
                     Endif
                  Endif
               Endif
            Endif
         Endif
      Endif

      'PCɕ
      Tach( Fan_chan ) = Fan_Tach
      Fan_status( Fan_chan ) = Fan_Tach
      Str1 = Tach_Str( Fan_Tach )
      Sgl1 = PWM_Duty( Fan_chan ) : Str2 = Duty_Str( Sgl1 )
      Str3 = Fanname( Fan_chan )  : Str3 = Name_Str( Str3 )
      Print "Fan," ; Str( Fan_chan ) ; "," ; Str3 ; "," ; Str1 ; "," ; Str2

      Call RcvPrm()
      Reset Watchdog

   Next Fan_chan

   'PCɕ
   Call SndPrm()
   Print Fancon_Rev

   'Write EEPROM if requested
    If WriteParamReq = 1 Then
      WriteEEPparam
      WriteParamReq = 0
    Endif

   'ŏIFan̖O"off"̂ƂAAUXPort0Low
    If Fanname( FAN_Max )  = "off" Then
       AUXPort0 = 0
    Else
       AUXPort0 = 1
    Endif

Loop

End

$eeprom
$eepromhex

Tmindata:
   Data   35% ,  35% ,  35% ,  35%
Tmaxdata:
   Data   50% ,  50% ,  50% ,  50%
Tstopdata:
   Data   30% ,  30% ,  30% ,  30%
Dmindata:
   Data   30% ,  30% ,  30% ,  30%
Dmaxdata:
   Data  100% , 100% , 100% , 100%
Dmandata:
   Data  100% , 100% , 100% , 100%
FanThmdata:
   Data    1% ,   2% ,   3% ,   4%
FanMandata:
   Data    0% ,   0% ,   0% ,   0%
FanPlsdata:
   Data    0% ,   0% ,   0% ,   0% ,   0% ,   0%
Fannamedata:
   Data "Fan001" , "Fan002" , "Fan003" , "Fan004" , "Fan005" , "Fan006"
Thmnamedaat:
   Data "Thm001" , "Thm002" , "Thm003" , "Thm004" , "Thm005" , "Thm006"
Tfnc5data:
   Data 25% , 25% , 25% , 25% , 1% , 0% , 0% , 0%
Tfnc6data:
   Data 25% , 25% , 25% , 25% , 0% , 1% , 0% , 0%
$data


'***********************************************************
'ʃ`l̃f[eB[ݒ

Sub Set_Speed( Fan_chan_arg As Byte )

   Local I_duty As Integer
   Local S_duty As Single

   S_duty = Pwm_duty( Fan_chan_arg ) / 100.0
   S_duty = Pwm_top( Fan_chan_arg ) * S_duty
   I_duty = Round( S_duty )

   If Stp_flag( Fan_chan_arg ) = 1 Then
      I_duty = 0
   End If

   Select Case Fan_chan_arg
      Case 1 : FAN1PWM = I_duty
      Case 2 : FAN2PWM = I_duty
      Case 3 : FAN3PWM = I_duty
      Case 4 : FAN4PWM = I_duty
      Case 5 : FAN3PWM = I_duty
      Case 6 : FAN4PWM = I_duty
   End Select

End Sub

'***********************************************************
'S`lS

Sub Set_Speed_full( )

   FAN6PWM = PWM_Top( 6 )
   FAN5PWM = PWM_Top( 5 )
   FAN4PWM = PWM_Top( 4 )
   FAN3PWM = PWM_Top( 3 )
   FAN2PWM = PWM_Top( 2 )
   FAN1PWM = PWM_Top( 1 )
   For Igr1 = 0 to PWM_Max
      Stp_flag( Igr1 ) = 0
   Next Igr1
   Waitms 3000

End Sub

'***********************************************************
'S`l~

Sub Set_speed_zero()

   FAN6PWM = 0
   FAN5PWM = 0
   FAN4PWM = 0
   FAN3PWM = 0
   FAN2PWM = 0
   FAN1PWM = 0
   For Igr1 = 0 to PWM_Max
      Stp_flag( Igr1 ) = 1
   Next Igr1

End Sub

'***********************************************************
'T[~X^̓d牷xvZ֐

Function Temperature( Thm_Volt_ratio_arg As Word ) As Single
   'Temperature     : Temperature(deg)
   'Thm_Volt_ratio  : Voltage ratio(0`1023)  of Thermistor channel
   ' Assume 99.9deg if Voltage ratio is over 1000 (terminal open) or under 1 (short)

   Local X As Single
   Local Y As Single

   X = Thm_Volt_ratio_arg
   Y = 1023.0 - X

   If X > 1000.0 Then
      Temperature = 99.9
   Elseif X <= 1.0 Then
      Temperature = 99.9
   Else
      Y = X / Y
      X = Log(Y)
      Y = 0.29112 * X
      X = Y + 3.1359
      Y = 1000.0 / X
      Temperature = Y - 273.0
   End If

End Function

'***********************************************************
'Calculate Enpanded Thermometer

Function ExpThm( Thm_chan_arg As Byte ) As Single
   'ExpThm : Temperature(deg)
   'Thm_chan_arg must be 5 or 6

   Local I As Integer , J As Integer
   Local X As Single

   ExpThm = 0.0
   If Thm_chan_arg > 0 Then
      If Thm_chan_arg <= 4 Then
         ExpThm = Temper( Thm_chan_arg )
      Elseif Thm_chan_arg <= 6 Then
         If Ext_eff_cnt > 0 Then    'When using an External alternative temperature
            If Exttemper( Thm_chan_arg ) > 5.0 Then
               ExpThm = Exttemper( Thm_chan_arg )
               Exit Function
            End If
         End If
         'Normal Function of Expanded Thermometer
         ExpThm = WtdAveTemp( Thm_chan_arg )
         For I = 1 to 4
            Select Case Thm_chan_arg
               Case 5 : J = Tfnc5( I + 4 )
               Case 6 : J = Tfnc6( I + 4 )
            End Select
            If J = 1 Then
               If Temper( I ) > ExpThm Then
                  ExpThm = Temper( I )
               End If
            End If
         Next I
      End If
   End If

End Function

'***********************************************************
'Calculate Weighted Average Temperature

Function WtdAveTemp( Thm_chan_arg As Byte ) As Single

   Local I As Integer, Weight As Integer
   Local X As Single

   WtdAveTemp = 0.0
   For I = 1 To 4
      If Temper( I ) < 99.9 Then
         Select Case Thm_chan_arg
            Case 5 : Weight = Tfnc5( I )
            Case 6 : Weight = Tfnc6( I )
            Case Else : Weight = 0
         End Select
         X = Temper ( I ) * Weight
         WtdAveTemp = WtdAveTemp + X
      End If
   Next I
   WtdAveTemp = WtdAveTemp * 0.01

End Function

'***********************************************************
'T[~X^̉xFanDutyvZ֐

Function Duty( Fan_chan_arg As Byte , Tmpr_arg As Single ) As Single
   'Fan_chan_arg :  FAN Channel
   'Tmpr_arg     :  Temperature(deg)
   'Duty         :  0.0`100.0(%)

   Local F As Byte
   Local D As Single , W As Single , X As Single , Y As Single , Z As Single
   Local S_ts As Single , S_tm As Single , S_tx As Single , S_dm As Single , S_dx As Single
   Local i As Integer

'During Manual setting
   If Fanman( Fan_chan_arg ) = 1 Then
      Duty = Dman( Fan_chan_arg )
      Stp_flag( Fan_chan_arg ) = 0
      Exit Sub
   End If

'During Automatic setting
   S_ts = Tstop( Fan_chan_arg )                                              ' S_Ts = Tstop
   S_tm = Tmin( Fan_chan_arg )                                               ' S_Tm = Tmin
   S_tx = Tmax( Fan_chan_arg )                                               ' S_Tx = Tmax
   S_dm = Dmin( Fan_chan_arg )                                               ' S_Dm = Dmin
   S_dx = Dmax( Fan_chan_arg )                                               ' S_Dx = Dmax

   F = Stp_flag( Fan_chan_arg )                              ' F 1:stop 0:run
   If Tmpr_arg <= S_ts Then                                 ' Stop Fan when Tmpr is under Tstop
      Duty = 0.0
      Stp_flag( Fan_chan_arg ) = 1
   Elseif Tmpr_arg <= S_tm Then                            ' When Tmpr is under Tmin
      If F = 1 Then                                         ' Continue stopping when Fan has already stopped
         Duty = 0.0
         Stp_flag( Fan_chan_arg ) = 1
      Else                                                  ' Run at Dmin when Fan is running
         Duty = S_dm
         Stp_flag( Fan_chan_arg ) = 0
      End If
   Elseif Tmpr_arg => S_tx Then                            ' Run at Dmax When Tmpr is over Tmax
      Duty = S_dx
      Stp_flag( Fan_chan_arg ) = 0
   Else                                                    ' When Tmpr is over Tmin and under Tmax
      If F = 0 Then
         W = Tmpr_arg - S_tm                                ' W=Tmpr-Tmin (deg)
         X = S_dx - S_dm                                    ' X=Dmax-Dmin (%)
         Y = S_tx - S_tm                                    ' Y=Tmax-Tmin (deg)
         Z = X / Y                                          ' Z:Slope     (%/deg)
         Y = Z * W                                          ' Y=slope*(Tmpr-Tmin)  (%)
         Duty = Y + S_dm                                    ' D=Y+Dmin    (%)
         Stp_flag( Fan_chan_arg ) = 0
      Else                                                 ' Run from stopping
         Duty = Dman( Fan_chan_arg )
         Stp_flag( Fan_chan_arg ) = 0
      End If
   End If

End Function


'***********************************************************
'Fan̉]vvZ֐

Function Fanspeed( Fan_chan_arg As Byte ) As Integer
   'Fan_chan_arg   :  FAN Channel
   'Fanspeed       :  FAN Tach (rpm)

   Local X As Integer , Y As Integer , Z As Single
   Local Fan_p0 As Byte , Fan_p1 As Byte
   Local Usb_cnt As Byte
   Local Fanpls_rate As Integer
   Local PlsRec As Byte

   Fanpls_rate = Fanpls( Fan_chan_arg )
   Fan_p0 = 0
   Fan_cnt = 0
   Tmr_total_cnt = 0
   Tmr_over_cnt = 0
   Timer2 = 0
   Enable Timer2
   Start Timer2

   Do

      Select Case Fan_chan_arg                          ' Polling Sensor channel
         Case 1 : Fan_p1 = Fan1Sens                      ' Fan#1
         Case 2 : Fan_p1 = Fan2Sens                      ' Fan#2
         Case 3 : Fan_p1 = Fan3Sens                      ' Fan#3
         Case 4 : Fan_p1 = Fan4Sens                      ' Fan#4
         Case 5 : Fan_p1 = Fan5Sens                      ' Fan#5
         Case 6 : Fan_p1 = Fan6Sens                      ' Fan#6
      End Select

      If Fan_p1 <> Fan_p0 Then                              ' When the pulse is inverted
         Fan_p0 = Fan_p1
         PlsRec = 0             ' Record Pulse  (Record when Fanpls is 0 or when Pulse is up at Fanpls not 0)
         If Fanpls_rate <>0 Then
            If Fan_p1 = 0 Then
               PlsRec = 1       ' Ignore Pulse  (Ignore when Pulse is down at Fanpls not 0)
            End If
         End If
         If PlsRec = 0 Then
            If Fan_cnt = 0 Then                                ' Initialize the first pulse
               Timer2 = 0
               Tmr_over_cnt = 0
               Fan_cnt = 1
               Tmr_total_cnt = 0
               Tmr_total_cnt_pr = 0
            Else                                               ' Second pulse or more
               Tmr_cnt_arg = Timer2
               Tmr_over_cnt_arg = Tmr_over_cnt
               X = Tmr_Count()
               Y = X - Tmr_total_cnt
               If Y >= Fan_puls_min_wdth Then                  ' When there is sufficient pulse width
                  Fan_cnt = Fan_cnt + 1
                  Tmr_total_cnt_pr = Tmr_total_cnt
                  Tmr_total_cnt = X
               Else                                            ' When the pulse width is less
                  If Fan_cnt > 1 Then
                     Fan_cnt = Fan_cnt - 1
                     Tmr_total_cnt = Tmr_total_cnt_pr
                  End If
               End If
            End If
         End If
      End If

      If Tmr_over_cnt >= Tmr_max Then
         Stop Timer2
         Disable TIMER2
         Exit Do
      End If

   Loop

   Fan_cnt = Fan_cnt - 1
   If Fan_cnt <= 0 Then
      Fanspeed = 0
   Elseif Tmr_total_cnt <= 0 Then
      Fanspeed = Tach( Fan_chan_arg )
   Else
      Z = Tmr_total_cnt * Tmr_cycle    ' Total measureing term (us)
      If Z > 0.0 Then
         Z = 60.0 / Z                  ' Tach = Fan_cnt / PulseRate * 60(s) / Time(us)
         Z = Z * 1000000.0
         If Fanpls_rate = 0 Then
            Z = Z / 4
         Else
            Z = Z / Fanpls_rate
         End If
         Z = Fan_cnt * Z
      Else
         Z = 0.0
      End If

      If Z < 10000. Then
         Fanspeed = Int(Z)
      Else
         Fanspeed = 9999
      End If
   End If

End Function


'***********************************************************
'Calcurate Total counts of Timer2

Function Tmr_Count() As Integer
   'Tmr_over_cnt_arg  :  Timer2 Overflow Count
   'Tmr_cnt_arg       :  Timer2 Count
   'Tmr_Count         :  Timer2 Total Count

   Local X As Integer
   Local Y As Integer

   X = Tmr_over_cnt_arg * Tmr_top
   Tmr_Count = X + Tmr_cnt_arg

End Function

'***********************************************************
'ob̃bZ[W󂯎ATu[`

Sub RcvPrm( )

   Local i As Integer, s As String*10
   i = 0
   USB_data = ""

   Do

      While Ischarwaiting() = 1    'VA|[gɕ񂪂ꍇ

         s = Inkey()
         If s = Chr(&H0A) Then
            Call WrtPrm( )
            USB_data = ""
         Else
            USB_data = USB_data + s
            i =0
         Endif

      Wend

      If USB_data = "" Then
         Exit Sub
      Else
         Waitms 1
         i = i + 1
      Endif

   Loop Until i >= 10

End sub


'***********************************************************
'ݒ肳Ăt@R萔o͂Tu[`

Sub SndPrm( )

   Local I As Integer , J As Integer , K As Integer
   Local S As String * 12
   Local Thm_chan_l As Byte , Fan_chan_l As Byte , Tmp_chan_l As Byte
   Local PrmNum_l As Integer , PrmVal_l As Integer

' Send Fancon Param ( Txxx,Dxxx,Fanxxx )
   For PrmNum_l = 1 To 8
      S = PrmNam( PrmNum_l )
      USB_Data = "Prm," + S
      For Fan_chan_l = 1 To PWM_Max
         J = PrmNum_l - 1
         J = J * PWM_Max
         J = J + Fan_chan_l
         PrmVal_l = FanPrm( J )
         S = Str(PrmVal_l)
         USB_Data = USB_Data + "," + S
      Next Fan_chan_l
      Print USB_Data           'USART
   Next PrmNum_l

' Send Fanpls
   USB_data = "Prm,FanPls"
   For Fan_chan_l = 1 To FAN_Max
       PrmVal_l = FanPls( Fan_chan_l )
       S = Str(PrmVal_l)
       USB_data = USB_data + ","
       USB_data = USB_data + s
   Next Fan_chan_l
   Print USB_data

' Send Fan Name
   USB_data = "Prm,FanNam"
   For Fan_chan_l = 1 To FAN_Max
       S = Fanname( Fan_chan_l )
       USB_data = USB_data + ","
       USB_data = USB_data + s
   Next Fan_chan_l
   Print USB_data

' Send Thm Name
   USB_data = "Prm,ThmNam"
   For Thm_chan_l = 1 To THM_Max
       S = Thmname( Thm_chan_l )
       USB_data = USB_data + ","
       USB_data = USB_data + S
   Next Thm_chan_l
   Print USB_data

' Send Expanded Thm Parameter
   For I = 5 To 6
      S = Str( I )
      Usb_data = "Prm,Tfnc," + S

      For K = 1 To 8
         Select Case I
            Case 5 : J = Tfnc5( K )
            Case 6 : J = Tfnc6( K )
         End Select
         S = Str(J)
         Usb_data = Usb_data + "," + S
      Next K
      Print USB_data
   Next I

' Send Firm Num
   USB_data = "Prm,Firm," + Firm_Version
   Print USB_data

End Sub

'***********************************************************
'ob̃bZ[Wt@R萔ݒ肷Tu[`

Sub WrtPrm( )


    Local Iarray As Integer
    Local I As Integer , J As Integer , K As Integer
    Local S1 As String * 10 , S2 As String * 7
    Local Thm_chan_l As Byte , Tmp_chan_l As Byte , Fan_chan_l As Byte
    Local StrOrder As String * 10 , StrItem As String * 10
    Local PrmNum_l As Integer , PrmVal_l As Integer

      Iarray = Split( Usb_data , Strarray(1) , "," )

      For Igr1 = 1 To Iarray
         Strarray( Igr1 ) = Trim( Strarray(Igr1) )
      Next Igr1
      StrOrder = Strarray(1)
      StrItem  = Strarray(2)

      If StrOrder = "SetPrm" Then

         Print "// " ; Usb_data
         WriteParamReq = 1  ' Set write EEPROM request flag

         If StrItem = "ThmNam" Then
            For Thm_chan_l = 1 To THM_Max
               J = Thm_chan_l + 2
               S1 = Strarray( J )
               S2 = Name_str( S1 )
               Thmname( Thm_chan_l ) = S2
            Next Thm_chan_l

         Elseif StrItem = "FanNam" Then
            For Fan_chan_l = 1 To FAN_Max
               J = Fan_chan_l + 2
               S1 = Strarray( J )
               S2 = Name_str( S1 )
               Fanname( Fan_chan_l ) = S2
            Next Fan_chan_l

         Elseif StrItem = "Tfnc" Then
            If Iarray >= 11 Then
               S1 = Strarray( 3 )
               I = Val( S1 )
               For J = 4 To 11
                  S1 = Strarray( J )
                  K = Val( S1 )
                  Select Case I
                     Case 5 : Tfnc5( J - 3 ) = K
                     Case 6 : Tfnc6( J - 3 ) = K
                  End Select
               Next J
            End If

         Elseif StrItem = "FanPls" Then
            If Iarray > 2 Then
               For J = 3 To Iarray
                   Fan_chan_l = J - 2
                   If Fan_chan_l <= FAN_Max Then
                      S1 = Strarray( J )
                      PrmVal_l = Val( S1 )
                      FanPls( Fan_chan_l ) = PrmVal_l
                   End If
               Next J
            End If

         Else
            For PrmNum_l = 1 to 8
               If StrItem = PrmNam( PrmNum_l ) Then
                  If Iarray > 2 Then
                     For J = 3 To Iarray
                         Fan_chan_l = J - 2
                         If Fan_chan_l <= PWM_Max Then
                            S1 = Strarray( J )
                            PrmVal_l = Val( S1 )
                            K = PrmNum_l - 1
                            K = K * PWM_Max
                            K = K + Fan_chan_l
                            FanPrm( K ) = PrmVal_l
                         End If
                     Next J
                  End If
               End If
            Next PrmNum_l

         End If

      Elseif StrOrder = "ExtThm" Then

            For Tmp_chan_l = 1 To THM_Max
               J = Tmp_chan_l + 1
               If J <= Iarray Then
                  Exttemper( Tmp_chan_l ) = Val(strarray(J))
               Else
                  Exttemper( Tmp_chan_l ) = 0.0
               End If
            Next Thm_chan_l
            Ext_eff_cnt = Ext_eff_cnt_max

      Elseif StrOrder = "TestOn" Then

         If Test_cnt <= 0 Then
            Igr1 = Val( StrItem )
            Fan_chan_l = Igr1
            Call Testmode( Fan_chan_l )
         End If

      Elseif StrOrder = "TestOff" Then

         Test_cnt = 0

         Igr1 = Val( StrItem )
         Fan_chan_l = Igr1
         Print "TestOff," ; Str( Fan_chan_l )
         Reset Watchdog

      End If

End Sub

'***********************************************************
'Read Fancon parameter from EEPROM
Sub ReadEEPparam()

   Local I As  Integer

   For I = 1 to PWM_Max

      Tmin(I)    = eTmin(I)              ' Temperature at minimum Fan Duty (deg)
      If Tmin(I) < -98 Then
         Tmin(I) = -98
      Elseif Tmin(I) > 98 Then
         Tmin(I) = 98
      End If

      Tmax(I)    = eTmax(I)              ' Temperature at maximum Fan Duty (deg)
      If Tmax(I) <= Tmin(I) Then
         Tmax(I) = Tmin(I) + 1
      Elseif Tmax(I) > 99 Then
         Tmax(I) = 99
      End If

      Tstop(I)   = eTstop(I)             ' Fan Stops under this Temperature(deg)
      If Tstop(I) < -99 Then
         Tstop(I) = -99
      Elseif Tstop(I) >= Tmin(I) Then
         Tstop(I) = Tmin(I) - 1
      End If

      Dmin(I)    = eDmin(I)              ' Minimum Fan Duty(%)
      If Dmin(I) < 0 Then
         Dmin(I) = 0
      Elseif Dmin(I) > 100 Then
         Dmin(I) = 100
      End If

      Dmax(I)    = eDmax(I)              ' Maximum Fam Duty(%)
      If Dmax(I) < 0 Then
         Dmax(I) = 0
      Elseif Dmax(I) > 100 Then
         Dmax(I) = 100
      End If

      Dman(I)    = eDman(I)              ' Manual Duty of Fan channel(%)
      If Dman(I) < 0 Then
         Dman(I) = 0
      Elseif Dman(I) > 100 Then
         Dman(I) = 100
      End If

      FanThm(I)  = eFanThm(I)            ' Number of Thermistor controling Fan cannel
      If FanThm(I) < 0 Then
         FanThm(I) = 0
      Elseif FanThm(I) > 6 Then
         FanThm(I) = 6
      End If

      Fanman(I)  = eFanman(I)            ' Manual or Auto control 1:Manual 0:Auto
      If Fanman(I) <> 1 Then
         Fanman(I) = 0
      End If

   Next I

   For I = 1 to FAN_Max

      Fanpls(I)  = eFanpls(I)            ' Fan Pulse Number in a Revolution 0:Normal Fan
      If Fanpls(I) < 0 Then
         Fanpls(I) = 0
      Elseif Fanpls(I) > 8 Then
         Fanpls(I) = 0
      End If

      Fanname(I) = eFanname(I)           ' Fan Name
      If Fanname(I) = "" Then
         Fanname(I) = "XXXXXX"
      End If

   Next I

   For I = 1 to THM_Max
      Thmname(I) = eThmname(I)           ' Thermistor Name
      If Thmname(I) = "" Then
         Thmname(I) = "XXXXXX"
      End If
   Next I

   For I = 1 to 8
      Tfnc5(I) = eTfnc5(I)                 ' Coefficiect for Tmp5 function
      Tfnc6(I) = eTfnc6(I)                 ' Coefficiect for Tmp6 function
   Next I

End Sub

'***********************************************************
'Write Fancon parameter to EEPROM
Sub WriteEEPparam()

   Local I As  Integer

   For I = 1 to PWM_Max

      If Tmin(I) < -98 Then
         Tmin(I) = -98
      Elseif Tmin(I) > 98 Then
         Tmin(I) = 98
      End If
      eTmin(I)    = Tmin(I)              ' Temperature at minimum Fan Duty (deg)

      If Tmax(I) <= Tmin(I) Then
         Tmax(I) = Tmin(I) + 1
      Elseif Tmax(I) > 99 Then
         Tmax(I) = 99
      End If
      eTmax(I)    = Tmax(I)              ' Temperature at maximum Fan Duty (deg)

      If Tstop(I) < -99 Then
         Tstop(I) = -99
      Elseif Tstop(I) >= Tmin(I) Then
         Tstop(I) = Tmin(I) - 1
      End If
      eTstop(I)   = Tstop(I)             ' Fan Stops under this Temperature(deg)

      If Dmin(I) < 0 Then
         Dmin(I) = 0
      Elseif Dmin(I) > 100 Then
         Dmin(I) = 100
      End If
      eDmin(I)    = Dmin(I)              ' Minimum Fan Duty(%)

      If Dmax(I) < 0 Then
         Dmax(I) = 0
      Elseif Dmax(I) > 100 Then
         Dmax(I) = 100
      End If
      eDmax(I)    = Dmax(I)              ' Maximum Fam Duty(%)

      If Dman(I) < 0 Then
         Dman(I) = 0
      Elseif Dman(I) > 100 Then
         Dman(I) = 100
      End If
      eDman(I)    = Dman(I)              ' Manual Duty of Fan channel(%)

      If FanThm(I) < 0 Then
         FanThm(I) = 0
      Elseif FanThm(I) > 6 Then
         FanThm(I) = 6
      End If
      eFanThm(I)  = FanThm(I)            ' Number of Thermistor controling Fan cannel

      If Fanman(I) <> 1 Then
         Fanman(I) = 0
      End If
      eFanman(I)  = Fanman(I)            ' Manual or Auto control 1:Manual 0:Auto

   Next I

   For I = 1 to FAN_Max

      If Fanpls(I) < 0 Then
         Fanpls(I) = 0
      Elseif Fanpls(I) > 8 Then
         Fanpls(I) = 0
      End If
      eFanpls(I)  = Fanpls(I)            ' Fan Pulse Number in a Revolution 0:Normal Fan

      If Fanname(I) = "" Then
         Fanname(I) = "XXXXXX"
      End If
      Str1 = Fanname(I)                  ' Fan Name
      Str1 = Name_Str( Str1 )
      eFanname(I) =  Str1

   Next I

   For I = 1 to THM_Max

      If Thmname(I) = "" Then
         Thmname(I) = "XXXXXX"
      End If
      Str1 = Thmname(I)                   ' Thermistor Name
      Str1 = Name_Str( Str1 )
      eThmname(I) = Str1

   Next I

   For I = 1 to 8

      eTfnc5(I) = Tfnc5(I)                 ' Coefficiect for Tmp5 function
      eTfnc6(I) = Tfnc6(I)                 ' Coefficiect for Tmp6 function

   Next I

End Sub

'-------------------------------------- Test Mode  ----------------------------------------
'
Sub TestMode( Test_mode_Fan_chan_arg As Byte )

   Local Fchan As Integer
   Local i1 As integer , i2 As Integer , i3 As  Integer
   Local s1 As String*10, s2 As String*10,  s3 As String*10
   Local r1 As Single

   Fchan = Test_mode_Fan_chan_arg
   Test_cnt = 0      'eXgJEgNA

   USB_data = "TestOn,"
   USB_data = USB_data + Str( Fchan )
   Print USB_data

   Do

      USB_data = ""
      While Ischarwaiting() = 1    'VA|[gɕ񂪂ꍇ
         s1 = Inkey()
         If s1 <> Chr( &H0A ) Then
            USB_data = USB_data + s1
         Endif
      Wend

      i1 = Len( USB_data )
      If i1 > 0 Then

         i2 = Split( USB_data , Strarray(1) , "," )
         If Strarray(1) = "Test" Then
            Test_cnt = 0             'eXgJEgNA
            s1 = Strarray(2)
            i3 = Val( s1 )       'FanChannel
            If Fchan = i3 Then
               s1 = Strarray(3)
               i3 = Val( s1 )  'Duty
               PWM_Duty( Test_mode_Fan_chan_arg ) = i3
               Stp_flag( Test_mode_Fan_chan_arg ) = 0
               Call Set_speed( Test_mode_Fan_chan_arg )
            End If
         Elseif Strarray(1) = "TestOff" Then
            USB_data = "TestOff,"
            USB_data = USB_data + Str( Fchan )
            Print USB_data
            Exit Sub
         End If
      End If

      Tmr_max   = Tmr_over_cnt_max2
      Fan_tach  = Fanspeed( Test_mode_Fan_chan_arg )
      s1 = Fanname( Test_mode_Fan_chan_arg )  : s1 = Name_Str( s1 )
      s2 = Tach_Str( Fan_tach )
      r1 = PWM_Duty( Test_mode_Fan_chan_arg ) : s3 = Duty_Str( r1 )

      USB_data = "Fan," + Str( Fchan ) + "," + s1 + "," + s2 + "," + s3
      Print USB_data

      Test_cnt = Test_cnt + 1      'eXgJEgCNg

      Reset Watchdog

   Loop Until Test_cnt > Test_Max 'eXgJEgɒBTu[`I

End Sub

'-------------------------------------- String Function ----------------------------------------

'***********************************************************
'Uɂt@NV  (Op)

Function Name_Str( Cliped_arg As String ) As String * 6

   Local i As Integer
   Local s As String * 10

   s = Trim( Cliped_arg )
   i = Len( s )
   i = 6 - i
   If i >= 6 Then
      Name_Str = "NoName"
   ElseIf i > 0 Then
      Name_Str = s + Space( i )
   Else
      Name_Str = Left( s , 6 )
   End If

End Function

'***********************************************************
'SEl̕ɂt@NV (]p)

Function Tach_Str( Tach_arg As Integer )  As String * 4

   Local s As String * 6
   Local i As Integer

   If Tach_arg =< 0 Then
      Tach_Str = "   0"
   Elseif Tach_arg > 9999 Then
      Tach_Str = "9999"
   Else
      s = Str( Tach_arg )
      i = Len( s )
      i = 4 - i
      If i > 0 Then
         s = Space( i ) + s
      Endif
      Tach_Str = Left( s , 4 )
   Endif

End Function

'*************************************************************************
'𐮐QAP̂SEl̕ɂt@NV (xp)

Function Temp_Str( Temp_arg As Single )  As String * 4

   Local s As String * 6
   Local i As Integer

   If Temp_arg <= 0.0 Then
      Temp_Str = " 0.0"
   Elseif Temp_arg > 99.9 Then
      Temp_Str = "99.9"
   Else
      s = Fusing( Temp_arg , "##.#" )
      i = Len( s )
      i = 4 - i
      If i > 0 Then
         s = Space( i ) + s
      Endif
      Temp_Str = Left( s , 4 )
   Endif

End Function

'*************************************************************************
'𐮐QAP̂SEl̕ɂt@NV (Dutyp)

Function Duty_Str( Duty_arg As Single )  As String * 4

   Local s As String * 6
   Local i As Integer

   If Duty_arg <= 0.0 Then
      Duty_Str = " 0.0"
   Elseif Duty_arg > 99.9 Then
      Duty_Str = "100."
   Else
      s = Fusing( Duty_arg , "##.#" )
      i = Len( s )
      i = 4 - i
      If i > 0 Then
         s = Space( i ) + s
      Endif
      Duty_Str = Left( s , 4 )
   Endif

End Function

'***********************************************************
'Timer荞݂̏
Tmr_int:

   Push R27
   Push R26
   PUSH R24
   IN   R24, SREG
   PUSH R24

   Incr Tmr_over_cnt

   POP  R24
   !OUT SREG, R24
   POP  R24
   POP  R26
   POP  R27

Return